/*
 * (c) Sébastien Adam 2012
 * Vous êtes libre de :
 *   partager — reproduire, distribuer et communiquer ce script
 *   remixer — adapter ce script
 * Selon les conditions suivantes :
 *   Attribution — Vous devez attribuer ce script de la manière indiquée par l'auteur de ce script ou le titulaire des droits (mais pas d'une manière qui suggérerait qu'ils vous soutiennent ou approuvent votre utilisation de ce script).
 *   Pas d’Utilisation Commerciale — Vous n'avez pas le droit d'utiliser ce script à des fins commerciales.
 *   Partage dans les Mêmes Conditions — Si vous modifiez, transformez ou adaptez ce script, vous n'avez le droit de distribuer votre création que sous une licence identique ou similaire à celle-ci.
 */

var guessedWord;
var idContainer = 'content';
var idxLevel;
var levels      = [{'label':'facile','value':10},{'label':'moyen','value':6},{'label':'difficile','value':3}];
var maxMistakes;
var nbrGames    = new Array(0,0,0);
var nbrMistakes;
var nbrWonGames = new Array(0,0,0);
var wordToFind;
var wrongLetters;

/*- C'est ici qu'on joue - Début ---------------------------------------------*/
function gessLetter(letter) {
  var idButton = 'button'+letter;
  var index = wordToFind.indexOf(letter);
  var found = false;
  var plural = '';
  $('#'+idButton).button({ disabled: true });
  $('#'+idButton).button("refresh");
  while(index > -1) {
    guessedWord = guessedWord.substring(0, index)+letter+guessedWord.substring(index+1);
    found = true;
    index = wordToFind.indexOf(letter, index+1);
  }
  if(!found) {
    ++nbrMistakes;
    wrongLetters.push(letter);
  }
  if(nbrMistakes == maxMistakes) {
    loseGame();
  } else if(guessedWord == wordToFind) {
    winGame();
  } else {
    if(nbrMistakes > 1) {
      plural = 's';
    }
    $('#guessedWord').text(guessedWord);
    $('#nbrMistakes').text(nbrMistakes);
    $('#plural1').text(plural);
    $('#plural2').text(plural);
    if(wrongLetters.length > 0) {
      $('#mistakesList').text('('+wrongLetters.join(', ')+')');
    }
  }
}
/*- C'est ici qu'on joue - Fin -----------------------------------------------*/

/*- Affichage de la page d'accueil - Début -----------------------------------*/
function initGame() {
  var strReturn = '';
  strReturn += '<p>\n';
  strReturn += '  Ceci est le jeu du pendu. Vous devez deviner un mot, une lettre à la fois. Si vous faites trop d\'erreurs, vous perdez&nbsp;!\n';
  strReturn += '</p>\n';
  strReturn += '<div id="level">\n';
  for(var i = 0; i < levels.length; ++i) {
    strReturn += '  <button value="'+levels[i]['value']+'">Jeu '+levels[i]['label']+'&nbsp;: vous avez droit à '+levels[i]['value']+' erreurs</button>\n';
  }
  strReturn += '</div>\n';
  $('#'+idContainer).html(strReturn);
  $('#level').buttonset();
  $('#level button').click(function(){
    $('#ajaxMessage').html('<p style="text-align:center;"><img src="'+imgLoaderPath+'" alt="En cours de chargement" title="En cours de chargement"></p>\n');
    maxMistakes = $(this).attr('value');
    for(var i in levels) {
      if(maxMistakes == levels[i]['value']) {
        idxLevel = i;
      }
    }
    $.ajax({
      cache:false,
      type:'GET',
      url:currentDir+'/getword.php',
      complete:function(jqXHR, textStatus) {
        switch(textStatus) {
          case 'success' :
            wordToFind = jqXHR.responseText;
            $('#ajaxMessage').html('');
            startGame();
            break;
          default:
            $('#ajaxMessage').html('<div class="ui-state-error ui-corner-all" style="padding: 0 .7em;"><p>Une erreur s\'est produite lors de la récupération du mot à trouver.</p></div>\n');
        }
      }
    });
  });
}
/*- Affichage de la page d'accueil - Fin -------------------------------------*/

/*- Oups! C'est perdu - Début ------------------------------------------------*/
function loseGame() {
  ++nbrGames[idxLevel];
  var strReturn = '';
  strReturn += '<div class="ui-widget">\n';
  strReturn += '<div class="ui-state-error ui-corner-all" style="padding: 0 .7em;">\n';
  strReturn += '<h2>Vous avez perdu&nbsp;!</h2>\n';
  strReturn += '</div>\n';
  strReturn += '</div>\n';
  strReturn += printStatistics();
  strReturn += '<p><button id="buttonNewGame">Recommencer</button></p>\n';
  $('#'+idContainer).html(strReturn);
  $('#buttonNewGame').button().click(function(){
    initGame();
  });
}
/*- Oups! C'est perdu - Fin --------------------------------------------------*/

/*- Affichage des statistiques - Début ---------------------------------------*/
function printStatistics() {
  var strReturn = '';
  strReturn += '<p>Le mot était&nbsp;: '+wordToFind+'.</p>\n';
  strReturn += '<p>Vous avez gagné '+nbrWonGames[idxLevel]+' jeux de niveau '+levels[idxLevel]['label']+' sur '+nbrGames[idxLevel]+' ('+Math.round((nbrWonGames[idxLevel]/nbrGames[idxLevel]*100))+'% de réussite).</p>\n';
  return strReturn;
}
/*- Affichage des statistiques - Fin -----------------------------------------*/

/*- Affichage de la page de jeu - Début --------------------------------------*/
function startGame() {
  var strReturn = '';
  guessedWord = new Array(wordToFind.length+1).join('_');
  nbrMistakes = 0;
  wrongLetters = new Array();
//  var plural = (nbrMistakes > 1?'s':'');
  strReturn += '<h2>Veuillez faire une proposition</h2>\n';
  strReturn += '<h3 style="letter-spacing: 4px;" id="guessedWord">'+guessedWord+'</h3>\n';
  strReturn += '<p>Vous avez fait <span id="nbrMistakes">'+nbrMistakes+'</span> mauvaise<span id="plural1"></span> proposition<span id="plural2"></span> <span id="mistakesList"></span> sur un maximum de '+maxMistakes+'.</p>\n';
  strReturn += '<p>\n';
  strReturn += 'Propositions&nbsp;:\n';
  strReturn += '<div id="lettersButton">\n';
  for(var i = 'A'.charCodeAt(0); i <= 'Z'.charCodeAt(0); ++i) {
    var letter = String.fromCharCode(i);
    strReturn += '<button id="button'+letter+'" class="monospace" value="'+letter+'">'+letter+'</button>\n';
  }
  strReturn += '</div>\n';
  strReturn += '</p>\n';
  strReturn += '<p><button id="buttonResign">Abandonner</button></p>\n';
  $('#'+idContainer).html(strReturn);
  $('#lettersButton button').button().click(function(){
    gessLetter($(this).attr('value'));
  });
  $('#buttonResign').button().click(function(){
    loseGame(idContainer);
  });
}
/*- Affichage de la page de jeu - Fin ----------------------------------------*/

/*- Génial! C'est gagné - Début ----------------------------------------------*/
function winGame() {
  ++nbrGames[idxLevel];
  ++nbrWonGames[idxLevel];
  var strReturn = '';
  strReturn += '<div class="ui-widget">\n';
  strReturn += '<div class="ui-state-highlight ui-corner-all" style="padding: 0 .7em;">\n';
  strReturn += '<h2>Vous avez gagné&nbsp;!</h2>\n';
  strReturn += '</div>\n';
  strReturn += '</div>\n';
  strReturn += printStatistics();
  strReturn += '<p><button id="buttonNewGame">Nouvelle partie</button></p>\n';
  $('#'+idContainer).html(strReturn);
  $('#buttonNewGame').button().click(function(){
    initGame();
  });
}
/*- Génial! C'est gagné - Fin ------------------------------------------------*/

$(document).ready(function() {
  var img = new Image();
  img.src=imgLoaderPath;
  initGame();
});

$(document).keyup(function(e){
  e.stopPropagation();
  var keyCodePressed = e.keyCode;
  var keyPressed = '';
  if((keyCodePressed >= 'A'.charCodeAt(0)) && (keyCodePressed <= 'Z'.charCodeAt(0))) {
    keyPressed = String.fromCharCode(keyCodePressed);
  } else if((keyCodePressed >= 'a'.charCodeAt(0)) && (keyCodePressed <= 'a'.charCodeAt(0))) {
    keyPressed = String.fromCharCode(keyCodePressed).toUpperCase();
  };
  if(keyPressed != '') {
    $('#button'+keyPressed).click();
  };
});
